"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var HttpModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpModule = void 0;
const common_1 = require("@nestjs/common");
const cache_manager_1 = require("@nestjs/cache-manager");
const http_service_1 = require("./http.service");
const cache_manager_redis_store_1 = require("cache-manager-redis-store");
let HttpModule = HttpModule_1 = class HttpModule {
    static register(options = {}) {
        const cacheOptions = this.configureCacheModule(options);
        return {
            module: HttpModule_1,
            imports: [cacheOptions],
            providers: [
                {
                    provide: http_service_1.HTTP_MODULE_OPTIONS,
                    useValue: options,
                },
            ],
        };
    }
    static registerAsync(options) {
        return {
            module: HttpModule_1,
            imports: [...(options.imports || []), cache_manager_1.CacheModule.register()],
            providers: [...this.createAsyncProviders(options)],
        };
    }
    static configureCacheModule(options) {
        const cacheConfig = options.cache || {};
        if (cacheConfig.redis) {
            return cache_manager_1.CacheModule.register({
                store: cache_manager_redis_store_1.redisStore,
                host: cacheConfig.redis.host || 'localhost',
                port: cacheConfig.redis.port || 6379,
                password: cacheConfig.redis.password,
                ttl: cacheConfig.ttl || 60000,
                max: cacheConfig.max || 100,
            });
        }
        return cache_manager_1.CacheModule.register({
            ttl: cacheConfig.ttl || 60000,
            max: cacheConfig.max || 100,
        });
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: options.useClass,
                useClass: options.useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: http_service_1.HTTP_MODULE_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: http_service_1.HTTP_MODULE_OPTIONS,
            useFactory: async (optionsFactory) => await optionsFactory.createHttpOptions(),
            inject: [options.useExisting || options.useClass],
        };
    }
};
exports.HttpModule = HttpModule;
exports.HttpModule = HttpModule = HttpModule_1 = __decorate([
    (0, common_1.Module)({
        imports: [],
        providers: [http_service_1.HttpService],
        exports: [http_service_1.HttpService],
    })
], HttpModule);
//# sourceMappingURL=http.module.js.map